KAS-BUILD(1)

NAME
kas-build - kas build plugin

SYNOPSIS

            kas build [-h] [--skip STEP] [--force-checkout] [--update] [-k]
                      [--target TARGET] [-c TASK] [--provenance {true,mode=min,mode=max}]
                      [config] [extra_bitbake_args ...]

DESCRIPTION

Checks out all necessary repositories and builds using bitbake as specified in the configuration file.

This plugin implements the kas build command.

When this command is executed, kas will checkout repositories, setup the build environment and then invoke bitbake to build the targets selected in the chosen config file.

When running with --provenance <true|mode=...> kas will generate an provenance attestation for the build. The attestation will be stored in attestation/kas-build.provenance.json in the build directory. For details about provenance, see the build attestation chapter.

Note:
        In provenance mode, the command returns with a non-zero exit code in case no artifact is found for at least one entry.

OPTIONS

Positional Arguments

    config
        Config file(s), separated by colon. Using .config.yaml in KAS_WORK_DIR if none is specified.

    extra_bitbake_args
        Extra arguments to pass to bitbake (typically requires separation via '--')

Named Arguments

    --skip=[]
        Skip build steps. To skip more than one step, use this argument multiple times.

        Possible choices: setup_dir, setup_home, make_non_interactive, init_setup_repos, repo_setup_loop, finish_setup_repos, repos_checkout, repos_apply_patches, setup_environ, write_bbconfig

    --force-checkout=False
        Always checkout the desired commit/branch/tag of each repository, discarding any local changes

    --update=False
        Pull new upstream changes to the desired branch even if it is already checked out locally

    -k, --keep-config-unchanged
        Skip steps that change the configuration

    --target
        Select target to build

    -c, --cmd, --task
        Select which task should be executed

    --provenance
        Enable provenance attestation generation

        Possible choices: true, mode=min, mode=max

SEE ALSO

kas-build-attestation(1),

  KAS

Part of the kas(1) suite.

Author
Daniel Wagner, Jan Kiszka, Claudius Heine

Copyright
Siemens and contributors, 2017-2025